import Ember from 'ember';

export default Ember.Component.extend({
   id: 'rack',
   width: 800,
   height: 600,
   nbColumns: 4,
   nbRows: 4,
   tickSize: 8,
   style: 1,
   bottles: null,

   frame: {
     frameBackgroundColor: '#DDDDDD',
     frameBorderColor: '#999999',
     frameBorderWidth: 3,
     frameCornerSize: 50,
     frameCornerShadow: true,
  },

  rack: {
     strokeColor: '#3322FF',
     strokeWidth: 3,
     bottleColor: '#00EE00',
     marginX: 10,
     marginY: 10,
     handle: 5,
     percentBottle: 0.70
  },

  rackPath: Ember.computed('width', 'height', 'nbColumns', 'nbRows', 'rack', 'tickSize', function() {
     let usefulWidth = this.get('width') - 2*this.get('rack.marginX');
     let usefulHeight = this.get('height') - 2*this.get('rack.marginY');
     let tick = this.get("tickSize");
     let incX = usefulWidth / this.get('nbColumns')/2;
     let incY = usefulHeight / this.get('nbRows')/2;
     let rayon = Math.min(incX - this.get('rack.handle'), incY);
     let line = "";
     for (var row=0; row < this.get('nbRows'); row++) {
        let cY = this.get('rack.marginY')+incY+row*2*incY;
        //line += "M "+this.get('rack.marginX')+" "+offsetY;
        for (var col=0; col < this.get('nbColumns'); col++) {
           let cX = this.get('rack.marginX')+incX+col*2*incX;
           line += "M "+(cX-tick)+" "+cY+" h "+2*tick+" M "+cX+" "+(cY-tick)+" v "+2*tick+" ";
           if (this.get('style')==1)
             line += "M "+(cX-rayon)+" "+cY+ "a"+rayon+" "+rayon+" 0 0 0 "+2*rayon+" 0";
        }
     }
     return line;
  })
});
